(define-module (alterator autoinstall)
  :use-module (alterator algo)
  :use-module (alterator woo)
  :export (autoinstall))

;;all incoming commands will walk throw constraints subsystem
(define (run-command next cmd)
  (next (list (cons (cons "constraints" (car cmd))
                    (cdr cmd)))))
  
(define (autoinstall filename)
  (lambda (cmds next)
    (call-with-input-file
        filename
      (lambda(port)
        (let loop ((cmd (read port)))
          (or (eof-object? cmd)
              (begin  (woo-catch
                       (thunk
                        (format #t "------~S...~%" (woo-get-option cmd 'autoinstall-message cmd))
                        (format #t "------ANSWER:~S~%" (run-command next cmd))
                        (format #t "------DONE~%"))
                       (lambda (reason)
                         (format #t "------FAILED~%")
                         (format #t "REASON:~S~%" reason)
                         (exit 1)))
                      (loop (read port)))))))))
